import { Ref, PropType } from 'vue';
import { SelectionMode } from '../types/selectionMode';
import { TreeViewFilterMethod, TreeViewLoadNodesAsyncMethod, TreeViewNodeMetaModel, TreeViewNodeMetaModelDefaultsMethod } from 'types/treeView';
declare var __VLS_1: {}, __VLS_27: {
    metaModel: TreeViewNodeMetaModel;
    customClasses: {
        treeViewNode?: string;
        treeViewNodeSelf?: string;
        treeViewNodeSelfSelected?: string;
        treeViewNodeSelfExpander?: string;
        treeViewNodeSelfExpanded?: string;
        treeViewNodeSelfExpandedIndicator?: string;
        treeViewNodeSelfSpacer?: string;
        treeViewNodeSelfLabel?: string;
        treeViewNodeSelfInput?: string;
        treeViewNodeSelfCheckbox?: string;
        treeViewNodeSelfRadio?: string;
        treeViewNodeSelfText?: string;
        treeViewNodeSelfAction?: string;
        treeViewNodeSelfAddChild?: string;
        treeViewNodeSelfAddChildIcon?: string;
        treeViewNodeSelfDelete?: string;
        treeViewNodeSelfDeleteIcon?: string;
        treeViewNodeChildrenWrapper?: string;
        treeViewNodeChildren?: string;
        treeViewNodeLoading?: string;
    };
    expanderId: string;
    canExpand: boolean;
    toggleNodeExpanded: () => boolean;
}, __VLS_29: {
    metaModel: TreeViewNodeMetaModel;
    customClasses: {
        treeViewNode?: string;
        treeViewNodeSelf?: string;
        treeViewNodeSelfSelected?: string;
        treeViewNodeSelfExpander?: string;
        treeViewNodeSelfExpanded?: string;
        treeViewNodeSelfExpandedIndicator?: string;
        treeViewNodeSelfSpacer?: string;
        treeViewNodeSelfLabel?: string;
        treeViewNodeSelfInput?: string;
        treeViewNodeSelfCheckbox?: string;
        treeViewNodeSelfRadio?: string;
        treeViewNodeSelfText?: string;
        treeViewNodeSelfAction?: string;
        treeViewNodeSelfAddChild?: string;
        treeViewNodeSelfAddChildIcon?: string;
        treeViewNodeSelfDelete?: string;
        treeViewNodeSelfDeleteIcon?: string;
        treeViewNodeChildrenWrapper?: string;
        treeViewNodeChildren?: string;
        treeViewNodeLoading?: string;
    };
    inputId: string;
    checkboxChangeHandler: (event: Event) => void;
}, __VLS_31: {
    metaModel: TreeViewNodeMetaModel;
    customClasses: {
        treeViewNode?: string;
        treeViewNodeSelf?: string;
        treeViewNodeSelfSelected?: string;
        treeViewNodeSelfExpander?: string;
        treeViewNodeSelfExpanded?: string;
        treeViewNodeSelfExpandedIndicator?: string;
        treeViewNodeSelfSpacer?: string;
        treeViewNodeSelfLabel?: string;
        treeViewNodeSelfInput?: string;
        treeViewNodeSelfCheckbox?: string;
        treeViewNodeSelfRadio?: string;
        treeViewNodeSelfText?: string;
        treeViewNodeSelfAction?: string;
        treeViewNodeSelfAddChild?: string;
        treeViewNodeSelfAddChildIcon?: string;
        treeViewNodeSelfDelete?: string;
        treeViewNodeSelfDeleteIcon?: string;
        treeViewNodeChildrenWrapper?: string;
        treeViewNodeChildren?: string;
        treeViewNodeLoading?: string;
    };
    inputId: string;
    radioGroupValues: Record<string, any>;
    radioChangeHandler: (event: Event) => void;
}, __VLS_33: {
    metaModel: TreeViewNodeMetaModel;
    customClasses: {
        treeViewNode?: string;
        treeViewNodeSelf?: string;
        treeViewNodeSelfSelected?: string;
        treeViewNodeSelfExpander?: string;
        treeViewNodeSelfExpanded?: string;
        treeViewNodeSelfExpandedIndicator?: string;
        treeViewNodeSelfSpacer?: string;
        treeViewNodeSelfLabel?: string;
        treeViewNodeSelfInput?: string;
        treeViewNodeSelfCheckbox?: string;
        treeViewNodeSelfRadio?: string;
        treeViewNodeSelfText?: string;
        treeViewNodeSelfAction?: string;
        treeViewNodeSelfAddChild?: string;
        treeViewNodeSelfAddChildIcon?: string;
        treeViewNodeSelfDelete?: string;
        treeViewNodeSelfDeleteIcon?: string;
        treeViewNodeChildrenWrapper?: string;
        treeViewNodeChildren?: string;
        treeViewNodeLoading?: string;
    };
}, __VLS_35: {
    metaModel: TreeViewNodeMetaModel;
    customClasses: {
        treeViewNode?: string;
        treeViewNodeSelf?: string;
        treeViewNodeSelfSelected?: string;
        treeViewNodeSelfExpander?: string;
        treeViewNodeSelfExpanded?: string;
        treeViewNodeSelfExpandedIndicator?: string;
        treeViewNodeSelfSpacer?: string;
        treeViewNodeSelfLabel?: string;
        treeViewNodeSelfInput?: string;
        treeViewNodeSelfCheckbox?: string;
        treeViewNodeSelfRadio?: string;
        treeViewNodeSelfText?: string;
        treeViewNodeSelfAction?: string;
        treeViewNodeSelfAddChild?: string;
        treeViewNodeSelfAddChildIcon?: string;
        treeViewNodeSelfDelete?: string;
        treeViewNodeSelfDeleteIcon?: string;
        treeViewNodeChildrenWrapper?: string;
        treeViewNodeChildren?: string;
        treeViewNodeLoading?: string;
    };
};
type __VLS_Slots = {} & {
    'loading-root'?: (props: typeof __VLS_1) => any;
} & {
    expander?: (props: typeof __VLS_27) => any;
} & {
    checkbox?: (props: typeof __VLS_29) => any;
} & {
    radio?: (props: typeof __VLS_31) => any;
} & {
    text?: (props: typeof __VLS_33) => any;
} & {
    loading?: (props: typeof __VLS_35) => any;
};
declare const __VLS_component: import("vue").DefineComponent<import("vue").ExtractPropTypes<{
    customAriaKeyMap: {
        type: ObjectConstructor;
        required: false;
        default: () => {};
        validator: (value: {
            [key: string]: any;
        }) => boolean;
    };
    filterMethod: {
        type: PropType<TreeViewFilterMethod>;
        required: false;
        default: null;
    };
    loadNodesAsync: {
        type: PropType<TreeViewLoadNodesAsyncMethod>;
        required: false;
        default: null;
    };
    modelDefaults: {
        type: PropType<TreeViewNodeMetaModelDefaultsMethod>;
        required: false;
        default(): {};
    };
    selectionMode: {
        type: PropType<SelectionMode>;
        required: false;
        default: SelectionMode;
        validator: (value: SelectionMode) => boolean;
    };
    skinClass: {
        type: StringConstructor;
        required: false;
        default: string;
        validator: (value: string | null) => boolean;
    };
    modelValue: {
        type: PropType<object[]>;
        required: true;
    };
}>, {
    getCheckedCheckboxes: () => TreeViewNodeMetaModel[];
    getCheckedRadioButtons: () => TreeViewNodeMetaModel[];
    getMatching: (matcherFunction: (current: TreeViewNodeMetaModel) => boolean, maxMatches?: number) => TreeViewNodeMetaModel[];
    getSelected: () => TreeViewNodeMetaModel[];
    metaModel: Ref<{
        [x: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: import("types/treeView").TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: import("types/treeView").TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../types/dragDrop").EffectAllowed;
        childMetaModels: any[];
        customizations: {
            classes: {
                treeViewNode?: string | undefined;
                treeViewNodeSelf?: string | undefined;
                treeViewNodeSelfSelected?: string | undefined;
                treeViewNodeSelfExpander?: string | undefined;
                treeViewNodeSelfExpanded?: string | undefined;
                treeViewNodeSelfExpandedIndicator?: string | undefined;
                treeViewNodeSelfSpacer?: string | undefined;
                treeViewNodeSelfLabel?: string | undefined;
                treeViewNodeSelfInput?: string | undefined;
                treeViewNodeSelfCheckbox?: string | undefined;
                treeViewNodeSelfRadio?: string | undefined;
                treeViewNodeSelfText?: string | undefined;
                treeViewNodeSelfAction?: string | undefined;
                treeViewNodeSelfAddChild?: string | undefined;
                treeViewNodeSelfAddChildIcon?: string | undefined;
                treeViewNodeSelfDelete?: string | undefined;
                treeViewNodeSelfDeleteIcon?: string | undefined;
                treeViewNodeChildrenWrapper?: string | undefined;
                treeViewNodeChildren?: string | undefined;
                treeViewNodeLoading?: string | undefined;
            };
        } | null;
        input: {
            type: import("../types/inputType").InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        } | null;
        state: {
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean | undefined;
                value?: boolean | undefined;
            };
        };
        _: {
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean | undefined;
                areChildrenLoaded?: boolean | undefined;
                matchesFilter?: boolean | undefined;
                subnodeMatchesFilter?: boolean | undefined;
            };
        };
    }[], TreeViewNodeMetaModel[] | {
        [x: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: import("types/treeView").TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: import("types/treeView").TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../types/dragDrop").EffectAllowed;
        childMetaModels: any[];
        customizations: {
            classes: {
                treeViewNode?: string | undefined;
                treeViewNodeSelf?: string | undefined;
                treeViewNodeSelfSelected?: string | undefined;
                treeViewNodeSelfExpander?: string | undefined;
                treeViewNodeSelfExpanded?: string | undefined;
                treeViewNodeSelfExpandedIndicator?: string | undefined;
                treeViewNodeSelfSpacer?: string | undefined;
                treeViewNodeSelfLabel?: string | undefined;
                treeViewNodeSelfInput?: string | undefined;
                treeViewNodeSelfCheckbox?: string | undefined;
                treeViewNodeSelfRadio?: string | undefined;
                treeViewNodeSelfText?: string | undefined;
                treeViewNodeSelfAction?: string | undefined;
                treeViewNodeSelfAddChild?: string | undefined;
                treeViewNodeSelfAddChildIcon?: string | undefined;
                treeViewNodeSelfDelete?: string | undefined;
                treeViewNodeSelfDeleteIcon?: string | undefined;
                treeViewNodeChildrenWrapper?: string | undefined;
                treeViewNodeChildren?: string | undefined;
                treeViewNodeLoading?: string | undefined;
            };
        } | null;
        input: {
            type: import("../types/inputType").InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        } | null;
        state: {
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean | undefined;
                value?: boolean | undefined;
            };
        };
        _: {
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean | undefined;
                areChildrenLoaded?: boolean | undefined;
                matchesFilter?: boolean | undefined;
                subnodeMatchesFilter?: boolean | undefined;
            };
        };
    }[]>;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    treeRootNodesLoad: (nodes: object[]) => void;
    treeNodeClick: (node: TreeViewNodeMetaModel, event: MouseEvent) => void;
    treeNodeDblclick: (node: TreeViewNodeMetaModel, event: MouseEvent) => void;
    treeNodeCheckboxChange: (node: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeChildCheckboxChange: (node: TreeViewNodeMetaModel, child: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeRadioChange: (node: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeExpandedChange: (node: TreeViewNodeMetaModel) => void;
    treeNodeChildrenLoad: (node: TreeViewNodeMetaModel) => void;
    treeNodeSelectedChange: (node: TreeViewNodeMetaModel) => void;
    treeNodeActivate: (node: TreeViewNodeMetaModel) => void;
    treeNodeAdd: (node: TreeViewNodeMetaModel, parent: TreeViewNodeMetaModel) => void;
    treeNodeDelete: (node: TreeViewNodeMetaModel) => void;
    "update:modelValue": (value: object[]) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    customAriaKeyMap: {
        type: ObjectConstructor;
        required: false;
        default: () => {};
        validator: (value: {
            [key: string]: any;
        }) => boolean;
    };
    filterMethod: {
        type: PropType<TreeViewFilterMethod>;
        required: false;
        default: null;
    };
    loadNodesAsync: {
        type: PropType<TreeViewLoadNodesAsyncMethod>;
        required: false;
        default: null;
    };
    modelDefaults: {
        type: PropType<TreeViewNodeMetaModelDefaultsMethod>;
        required: false;
        default(): {};
    };
    selectionMode: {
        type: PropType<SelectionMode>;
        required: false;
        default: SelectionMode;
        validator: (value: SelectionMode) => boolean;
    };
    skinClass: {
        type: StringConstructor;
        required: false;
        default: string;
        validator: (value: string | null) => boolean;
    };
    modelValue: {
        type: PropType<object[]>;
        required: true;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((value: object[]) => any) | undefined;
    onTreeRootNodesLoad?: ((nodes: object[]) => any) | undefined;
    onTreeNodeClick?: ((node: TreeViewNodeMetaModel, event: MouseEvent) => any) | undefined;
    onTreeNodeDblclick?: ((node: TreeViewNodeMetaModel, event: MouseEvent) => any) | undefined;
    onTreeNodeCheckboxChange?: ((node: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeChildCheckboxChange?: ((node: TreeViewNodeMetaModel, child: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeRadioChange?: ((node: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeExpandedChange?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeChildrenLoad?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeSelectedChange?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeActivate?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeAdd?: ((node: TreeViewNodeMetaModel, parent: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeDelete?: ((node: TreeViewNodeMetaModel) => any) | undefined;
}>, {
    customAriaKeyMap: Record<string, any>;
    filterMethod: TreeViewFilterMethod;
    loadNodesAsync: TreeViewLoadNodesAsyncMethod;
    modelDefaults: TreeViewNodeMetaModelDefaultsMethod;
    selectionMode: SelectionMode;
    skinClass: string;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
declare const _default: __VLS_WithSlots<typeof __VLS_component, __VLS_Slots>;
export default _default;
type __VLS_WithSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
declare global {
    const __VLS_intrinsicElements: __VLS_IntrinsicElements;
    const __VLS_directiveBindingRestFields: {
        instance: null;
        oldValue: null;
        modifiers: any;
        dir: any;
    };
    const __VLS_unref: typeof import('vue').unref;
    const __VLS_placeholder: any;
    type __VLS_NativeElements = __VLS_SpreadMerge<SVGElementTagNameMap, HTMLElementTagNameMap>;
    type __VLS_IntrinsicElements = import('vue/jsx-runtime').JSX.IntrinsicElements;
    type __VLS_Element = import('vue/jsx-runtime').JSX.Element;
    type __VLS_GlobalComponents = import('vue').GlobalComponents;
    type __VLS_GlobalDirectives = import('vue').GlobalDirectives;
    type __VLS_IsAny<T> = 0 extends 1 & T ? true : false;
    type __VLS_PickNotAny<A, B> = __VLS_IsAny<A> extends true ? B : A;
    type __VLS_SpreadMerge<A, B> = Omit<A, keyof B> & B;
    type __VLS_WithComponent<N0 extends string, LocalComponents, Self, N1 extends string, N2 extends string, N3 extends string> = N1 extends keyof LocalComponents ? N1 extends N0 ? Pick<LocalComponents, N0 extends keyof LocalComponents ? N0 : never> : {
        [K in N0]: LocalComponents[N1];
    } : N2 extends keyof LocalComponents ? N2 extends N0 ? Pick<LocalComponents, N0 extends keyof LocalComponents ? N0 : never> : {
        [K in N0]: LocalComponents[N2];
    } : N3 extends keyof LocalComponents ? N3 extends N0 ? Pick<LocalComponents, N0 extends keyof LocalComponents ? N0 : never> : {
        [K in N0]: LocalComponents[N3];
    } : Self extends object ? {
        [K in N0]: Self;
    } : N1 extends keyof __VLS_GlobalComponents ? N1 extends N0 ? Pick<__VLS_GlobalComponents, N0 extends keyof __VLS_GlobalComponents ? N0 : never> : {
        [K in N0]: __VLS_GlobalComponents[N1];
    } : N2 extends keyof __VLS_GlobalComponents ? N2 extends N0 ? Pick<__VLS_GlobalComponents, N0 extends keyof __VLS_GlobalComponents ? N0 : never> : {
        [K in N0]: __VLS_GlobalComponents[N2];
    } : N3 extends keyof __VLS_GlobalComponents ? N3 extends N0 ? Pick<__VLS_GlobalComponents, N0 extends keyof __VLS_GlobalComponents ? N0 : never> : {
        [K in N0]: __VLS_GlobalComponents[N3];
    } : {
        [K in N0]: unknown;
    };
    type __VLS_FunctionalComponentProps<T, K> = '__ctx' extends keyof __VLS_PickNotAny<K, {}> ? K extends {
        __ctx?: {
            props?: infer P;
        };
    } ? NonNullable<P> : never : T extends (props: infer P, ...args: any) => any ? P : {};
    type __VLS_IsFunction<T, K> = K extends keyof T ? __VLS_IsAny<T[K]> extends false ? unknown extends T[K] ? false : true : false : false;
    type __VLS_NormalizeComponentEvent<Props, Events, onEvent extends keyof Props, Event extends keyof Events, CamelizedEvent extends keyof Events> = (__VLS_IsFunction<Props, onEvent> extends true ? Props : __VLS_IsFunction<Events, Event> extends true ? {
        [K in onEvent]?: Events[Event];
    } : __VLS_IsFunction<Events, CamelizedEvent> extends true ? {
        [K in onEvent]?: Events[CamelizedEvent];
    } : Props) & Record<string, unknown>;
    type __VLS_UnionToIntersection<U> = (U extends unknown ? (arg: U) => unknown : never) extends ((arg: infer P) => unknown) ? P : never;
    type __VLS_OverloadUnionInner<T, U = unknown> = U & T extends (...args: infer A) => infer R ? U extends T ? never : __VLS_OverloadUnionInner<T, Pick<T, keyof T> & U & ((...args: A) => R)> | ((...args: A) => R) : never;
    type __VLS_OverloadUnion<T> = Exclude<__VLS_OverloadUnionInner<(() => never) & T>, T extends () => never ? never : () => never>;
    type __VLS_ConstructorOverloads<T> = __VLS_OverloadUnion<T> extends infer F ? F extends (event: infer E, ...args: infer A) => any ? {
        [K in E & string]: (...args: A) => void;
    } : never : never;
    type __VLS_NormalizeEmits<T> = __VLS_PrettifyGlobal<__VLS_UnionToIntersection<__VLS_ConstructorOverloads<T> & {
        [K in keyof T]: T[K] extends any[] ? {
            (...args: T[K]): void;
        } : never;
    }>>;
    type __VLS_PrettifyGlobal<T> = {
        [K in keyof T]: T[K];
    } & {};
    type __VLS_PickFunctionalComponentCtx<T, K> = NonNullable<__VLS_PickNotAny<'__ctx' extends keyof __VLS_PickNotAny<K, {}> ? K extends {
        __ctx?: infer Ctx;
    } ? Ctx : never : any, T extends (props: any, ctx: infer Ctx) => any ? Ctx : any>>;
    type __VLS_UseTemplateRef<T> = Readonly<import('vue').ShallowRef<T | null>>;
    function __VLS_getVForSourceType<T extends number | string | any[] | Iterable<any>>(source: T): [
        item: T extends number ? number : T extends string ? string : T extends any[] ? T[number] : T extends Iterable<infer T1> ? T1 : any,
        index: number
    ][];
    function __VLS_getVForSourceType<T>(source: T): [
        item: T[keyof T],
        key: keyof T,
        index: number
    ][];
    function __VLS_getSlotParams<T>(slot: T): Parameters<__VLS_PickNotAny<NonNullable<T>, (...args: any[]) => any>>;
    function __VLS_getSlotParam<T>(slot: T): Parameters<__VLS_PickNotAny<NonNullable<T>, (...args: any[]) => any>>[0];
    function __VLS_asFunctionalDirective<T>(dir: T): T extends import('vue').ObjectDirective ? NonNullable<T['created' | 'beforeMount' | 'mounted' | 'beforeUpdate' | 'updated' | 'beforeUnmount' | 'unmounted']> : T extends (...args: any) => any ? T : (arg1: unknown, arg2: unknown, arg3: unknown, arg4: unknown) => void;
    function __VLS_makeOptional<T>(t: T): {
        [K in keyof T]?: T[K];
    };
    function __VLS_asFunctionalComponent<T, K = T extends new (...args: any) => any ? InstanceType<T> : unknown>(t: T, instance?: K): T extends new (...args: any) => any ? (props: (K extends {
        $props: infer Props;
    } ? Props : any) & Record<string, unknown>, ctx?: any) => __VLS_Element & {
        __ctx?: {
            attrs?: any;
            slots?: K extends {
                $slots: infer Slots;
            } ? Slots : any;
            emit?: K extends {
                $emit: infer Emit;
            } ? Emit : any;
            expose?(exposed: K): void;
            props?: (K extends {
                $props: infer Props;
            } ? Props : any) & Record<string, unknown>;
        };
    } : T extends () => any ? (props: {}, ctx?: any) => ReturnType<T> : T extends (...args: any) => any ? T : (_: {} & Record<string, unknown>, ctx?: any) => {
        __ctx?: {
            attrs?: any;
            expose?: any;
            slots?: any;
            emit?: any;
            props?: {} & Record<string, unknown>;
        };
    };
    function __VLS_functionalComponentArgsRest<T extends (...args: any) => any>(t: T): 2 extends Parameters<T>['length'] ? [any] : [];
    function __VLS_asFunctionalElement<T>(tag: T, endTag?: T): (attrs: T & Record<string, unknown>) => void;
    function __VLS_asFunctionalSlot<S>(slot: S): S extends () => infer R ? (props: {}) => R : NonNullable<S>;
    function __VLS_tryAsConstant<const T>(t: T): T;
}
