import { PropType } from 'vue';
import { SelectionMode } from '../types/selectionMode';
import { TreeViewNodeMetaModelCustomizations, TreeViewNodeMetaModel, TreeViewNodeMetaModelDefaultsMethod } from 'types/treeView';
import { DropEventData } from 'types/dragDrop';
type __VLS_Slots = {
    expander(props: {
        metaModel: TreeViewNodeMetaModel;
        customClasses: TreeViewNodeMetaModelCustomizations["classes"];
        expanderId: string;
        canExpand: boolean;
        toggleNodeExpanded: () => boolean;
    }): void;
    checkbox(props: {
        metaModel: TreeViewNodeMetaModel;
        customClasses: TreeViewNodeMetaModelCustomizations["classes"];
        inputId: string;
        checkboxChangeHandler: (event: Event) => void;
    }): void;
    radio(props: {
        metaModel: TreeViewNodeMetaModel;
        customClasses: TreeViewNodeMetaModelCustomizations["classes"];
        inputId: string;
        radioGroupValues: Record<string, any>;
        radioChangeHandler: (event: Event) => void;
    }): void;
    text(props: {
        metaModel: TreeViewNodeMetaModel;
        customClasses: TreeViewNodeMetaModelCustomizations["classes"];
    }): void;
    loading(props: {
        metaModel: TreeViewNodeMetaModel;
        customClasses: TreeViewNodeMetaModelCustomizations["classes"];
    }): void;
};
declare const __VLS_component: import("vue").DefineComponent<import("vue").ExtractPropTypes<{
    ariaKeyMap: {
        type: ObjectConstructor;
        required: true;
    };
    depth: {
        type: NumberConstructor;
        required: true;
    };
    initialRadioGroupValues: {
        type: PropType<Record<string, string>>;
        required: true;
    };
    isMounted: {
        type: BooleanConstructor;
        required: true;
    };
    modelDefaults: {
        type: PropType<TreeViewNodeMetaModelDefaultsMethod>;
        required: true;
    };
    selectionMode: {
        type: PropType<SelectionMode>;
        required: false;
        default: SelectionMode;
        validator: (value: SelectionMode) => boolean;
    };
    treeId: {
        type: StringConstructor;
        required: true;
    };
    modelValue: {
        type: PropType<TreeViewNodeMetaModel>;
        required: true;
    };
}>, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    treeNodeClick: (node: TreeViewNodeMetaModel, event: MouseEvent) => void;
    treeNodeDblclick: (node: TreeViewNodeMetaModel, event: MouseEvent) => void;
    treeNodeCheckboxChange: (node: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeChildCheckboxChange: (node: TreeViewNodeMetaModel, child: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeRadioChange: (node: TreeViewNodeMetaModel, event: Event) => void;
    treeNodeExpandedChange: (node: TreeViewNodeMetaModel) => void;
    treeNodeChildrenLoad: (node: TreeViewNodeMetaModel) => void;
    treeNodeSelectedChange: (node: TreeViewNodeMetaModel) => void;
    treeNodeActivate: (node: TreeViewNodeMetaModel) => void;
    treeNodeAriaFocusableChange: (node: TreeViewNodeMetaModel) => void;
    treeNodeAriaRequestFirstFocus: (keepCurrentDomFocus?: boolean | undefined) => void;
    treeNodeAriaRequestLastFocus: () => void;
    treeNodeAriaRequestParentFocus: () => void;
    treeNodeAriaRequestPreviousFocus: (node: TreeViewNodeMetaModel) => void;
    treeNodeAriaRequestNextFocus: (node: TreeViewNodeMetaModel, keepCurrentDomFocus: boolean) => void;
    treeNodeAdd: (node: TreeViewNodeMetaModel, parent: TreeViewNodeMetaModel) => void;
    treeNodeDelete: (node: TreeViewNodeMetaModel) => void;
    treeNodeDragMove: (node: TreeViewNodeMetaModel, event: DragEvent) => void;
    treeNodeDrop: (data: DropEventData, event: DragEvent) => void;
    "update:modelValue": (value: TreeViewNodeMetaModel) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    ariaKeyMap: {
        type: ObjectConstructor;
        required: true;
    };
    depth: {
        type: NumberConstructor;
        required: true;
    };
    initialRadioGroupValues: {
        type: PropType<Record<string, string>>;
        required: true;
    };
    isMounted: {
        type: BooleanConstructor;
        required: true;
    };
    modelDefaults: {
        type: PropType<TreeViewNodeMetaModelDefaultsMethod>;
        required: true;
    };
    selectionMode: {
        type: PropType<SelectionMode>;
        required: false;
        default: SelectionMode;
        validator: (value: SelectionMode) => boolean;
    };
    treeId: {
        type: StringConstructor;
        required: true;
    };
    modelValue: {
        type: PropType<TreeViewNodeMetaModel>;
        required: true;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((value: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeClick?: ((node: TreeViewNodeMetaModel, event: MouseEvent) => any) | undefined;
    onTreeNodeDblclick?: ((node: TreeViewNodeMetaModel, event: MouseEvent) => any) | undefined;
    onTreeNodeCheckboxChange?: ((node: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeChildCheckboxChange?: ((node: TreeViewNodeMetaModel, child: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeRadioChange?: ((node: TreeViewNodeMetaModel, event: Event) => any) | undefined;
    onTreeNodeExpandedChange?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeChildrenLoad?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeSelectedChange?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeActivate?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeAriaFocusableChange?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeAriaRequestFirstFocus?: ((keepCurrentDomFocus?: boolean | undefined) => any) | undefined;
    onTreeNodeAriaRequestLastFocus?: (() => any) | undefined;
    onTreeNodeAriaRequestParentFocus?: (() => any) | undefined;
    onTreeNodeAriaRequestPreviousFocus?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeAriaRequestNextFocus?: ((node: TreeViewNodeMetaModel, keepCurrentDomFocus: boolean) => any) | undefined;
    onTreeNodeAdd?: ((node: TreeViewNodeMetaModel, parent: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeDelete?: ((node: TreeViewNodeMetaModel) => any) | undefined;
    onTreeNodeDragMove?: ((node: TreeViewNodeMetaModel, event: DragEvent) => any) | undefined;
    onTreeNodeDrop?: ((data: DropEventData, event: DragEvent) => any) | undefined;
}>, {
    selectionMode: SelectionMode;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
declare const _default: __VLS_WithSlots<typeof __VLS_component, __VLS_Slots>;
export default _default;
type __VLS_WithSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
