import { TreeViewNodeMetaModel } from 'types/treeView';
export declare function useTreeViewFocus(): {
    focusableNodeMetaModel: import("vue").Ref<{
        [x: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: import("types/treeView").TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: import("types/treeView").TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../../types/dragDrop").EffectAllowed;
        childMetaModels: any[];
        customizations: {
            classes: {
                treeViewNode?: string | undefined;
                treeViewNodeSelf?: string | undefined;
                treeViewNodeSelfSelected?: string | undefined;
                treeViewNodeSelfExpander?: string | undefined;
                treeViewNodeSelfExpanded?: string | undefined;
                treeViewNodeSelfExpandedIndicator?: string | undefined;
                treeViewNodeSelfSpacer?: string | undefined;
                treeViewNodeSelfLabel?: string | undefined;
                treeViewNodeSelfInput?: string | undefined;
                treeViewNodeSelfCheckbox?: string | undefined;
                treeViewNodeSelfRadio?: string | undefined;
                treeViewNodeSelfText?: string | undefined;
                treeViewNodeSelfAction?: string | undefined;
                treeViewNodeSelfAddChild?: string | undefined;
                treeViewNodeSelfAddChildIcon?: string | undefined;
                treeViewNodeSelfDelete?: string | undefined;
                treeViewNodeSelfDeleteIcon?: string | undefined;
                treeViewNodeChildrenWrapper?: string | undefined;
                treeViewNodeChildren?: string | undefined;
                treeViewNodeLoading?: string | undefined;
            };
        } | null;
        input: {
            type: import("../../types/inputType").InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        } | null;
        state: {
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean | undefined;
                value?: boolean | undefined;
            };
        };
        _: {
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean | undefined;
                areChildrenLoaded?: boolean | undefined;
                matchesFilter?: boolean | undefined;
                subnodeMatchesFilter?: boolean | undefined;
            };
        };
    } | null, TreeViewNodeMetaModel | {
        [x: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: import("types/treeView").TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: import("types/treeView").TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../../types/dragDrop").EffectAllowed;
        childMetaModels: any[];
        customizations: {
            classes: {
                treeViewNode?: string | undefined;
                treeViewNodeSelf?: string | undefined;
                treeViewNodeSelfSelected?: string | undefined;
                treeViewNodeSelfExpander?: string | undefined;
                treeViewNodeSelfExpanded?: string | undefined;
                treeViewNodeSelfExpandedIndicator?: string | undefined;
                treeViewNodeSelfSpacer?: string | undefined;
                treeViewNodeSelfLabel?: string | undefined;
                treeViewNodeSelfInput?: string | undefined;
                treeViewNodeSelfCheckbox?: string | undefined;
                treeViewNodeSelfRadio?: string | undefined;
                treeViewNodeSelfText?: string | undefined;
                treeViewNodeSelfAction?: string | undefined;
                treeViewNodeSelfAddChild?: string | undefined;
                treeViewNodeSelfAddChildIcon?: string | undefined;
                treeViewNodeSelfDelete?: string | undefined;
                treeViewNodeSelfDeleteIcon?: string | undefined;
                treeViewNodeChildrenWrapper?: string | undefined;
                treeViewNodeChildren?: string | undefined;
                treeViewNodeLoading?: string | undefined;
            };
        } | null;
        input: {
            type: import("../../types/inputType").InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        } | null;
        state: {
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean | undefined;
                value?: boolean | undefined;
            };
        };
        _: {
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean | undefined;
                areChildrenLoaded?: boolean | undefined;
                matchesFilter?: boolean | undefined;
                subnodeMatchesFilter?: boolean | undefined;
            };
        };
    } | null>;
    handleFocusableChange: (newMetaModel: TreeViewNodeMetaModel) => void;
};
