import { MaybeRef } from 'vue';
import { TreeViewNodeMetaModel, TreeViewNodeMetaModelDefaults } from 'types/treeView';
export declare function useTreeViewDataUpdates(model: MaybeRef<object[]>, metaModel: MaybeRef<TreeViewNodeMetaModelDefaults[]> | MaybeRef<TreeViewNodeMetaModel[]>): {
    spliceNodeList: (index: number, deleteCount: number, ...newItems: object[]) => TreeViewNodeMetaModel[] | Partial<{
        [key: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: import("types/treeView").TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: import("types/treeView").TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../types/dragDrop").EffectAllowed;
    } & {
        childMetaModels: TreeViewNodeMetaModelDefaults[];
        customizations: Partial<import("types/treeView").TreeViewNodeMetaModelCustomizations>;
        input: Partial<{
            type: import("../types/inputType").InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        }> | null;
        state: Partial<{
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean;
                value?: boolean;
            };
        }>;
        _: Partial<{
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean;
                areChildrenLoaded?: boolean;
                matchesFilter?: boolean;
                subnodeMatchesFilter?: boolean;
            };
        }>;
    }>[];
};
