import { TreeViewNodeMetaModel } from "./treeView";
export declare enum DropEffect {
    None = "none",
    Copy = "copy",
    Move = "move",
    Link = "link"
}
export declare enum EffectAllowed {
    None = "none",
    All = "all",
    Copy = "copy",
    Move = "move",
    Link = "link",
    CopyMove = "copyMove",
    CopyLink = "copyLink",
    LinkMove = "linkMove"
}
export declare enum TargetZone {
    Before = 0,
    After = 1,
    Child = 2
}
export interface DragPayload {
    treeId: string;
    data: TreeViewNodeMetaModel;
}
export interface DropEventData {
    isSameTree: boolean;
    droppedModel: TreeViewNodeMetaModel;
    targetModel: TreeViewNodeMetaModel;
    siblingNodeSets: {
        nodes: {
            [key: string]: any;
        }[];
        metaNodes: TreeViewNodeMetaModel[];
    } | null;
    dropEffect: DropEffect;
    targetZone: TargetZone;
}
