import { InputType } from '../../src/types/inputType';
import type { TreeViewAddChildCallbackMethod, TreeViewLoadChildNodesAsyncMethod, TreeViewNodeMetaModel, TreeViewNodeMetaModelDefaults, TreeViewNodeMetaModelDefaultsMethod } from "../../src/types/treeView";
type NodeSpec = Array<string | NodeSpec>;
export type TestTreeViewNode = {
    id: string;
    label: string;
    children: TestTreeViewNode[];
};
export declare function generateNodes(nodeSpec: NodeSpec, baseId?: string, addChildCallback?: TreeViewAddChildCallbackMethod | null, loadChildrenAsync?: TreeViewLoadChildNodesAsyncMethod | null): {
    nodes: TestTreeViewNode[];
    modelDefaultMap: Map<string, Partial<{
        [key: string]: any;
        data: {
            [key: string]: any;
        };
        idProperty: string;
        labelProperty: string;
        childrenProperty: string;
        title: string | null;
        expanderTitle: string | null;
        addChildTitle: string | null;
        deleteTitle: string | null;
        loadChildrenAsync: TreeViewLoadChildNodesAsyncMethod | null;
        addChildCallback: TreeViewAddChildCallbackMethod | null;
        deleteNodeCallback: import("../../src/types/treeView").TreeViewDeleteNodeCallbackMethod | null;
        expandable: boolean;
        selectable: boolean;
        deletable: boolean;
        focusable: boolean;
        draggable: boolean;
        allowDrop: boolean;
        dataTransferEffectAllowed: import("../../grapoza-tree-lib").EffectAllowed;
    } & {
        childMetaModels: TreeViewNodeMetaModelDefaults[];
        customizations: Partial<import("../../src/types/treeView").TreeViewNodeMetaModelCustomizations>;
        input: Partial<{
            type: InputType;
            name: string | null;
            value: string;
            isInitialRadioGroupValue: boolean;
        }> | null;
        state: Partial<{
            expanded: boolean;
            selected: boolean;
            input: {
                disabled?: boolean;
                value?: boolean;
            };
        }>;
        _: Partial<{
            dragging: boolean;
            dragMoved: boolean;
            isDropTarget: boolean;
            isPrevDropTarget: boolean;
            isNextDropTarget: boolean;
            isChildDropTarget: boolean;
            keepCurrentDomFocus: boolean;
            state: {
                areChildrenLoading?: boolean;
                areChildrenLoaded?: boolean;
                matchesFilter?: boolean;
                subnodeMatchesFilter?: boolean;
            };
        }>;
    }>>;
    modelDefaults: TreeViewNodeMetaModelDefaultsMethod;
};
export declare function generateMetaNodes(nodeSpec: NodeSpec, baseId?: string, addChildCallback?: TreeViewAddChildCallbackMethod | null, loadChildrenAsync?: TreeViewLoadChildNodesAsyncMethod | null): TreeViewNodeMetaModel[];
export declare function generateNodesAndMetaNodes(nodeSpec: NodeSpec, baseId?: string, addChildCallback?: TreeViewAddChildCallbackMethod | null, loadChildrenAsync?: TreeViewLoadChildNodesAsyncMethod | null): {
    nodes: TestTreeViewNode[];
    metaNodes: TreeViewNodeMetaModel[];
};
export {};
